// keycaptcha

using System;
using System.Collections;
using DeathByCaptcha;

namespace DeathByCaptcha
{
    public class KeyCaptchaExample
    {
        static public void Main(string[] argv)
        {
            // Put your DeathByCaptcha account username and password here.
            string username = "your username";
            string password = "your password";
            // string token_from_panel = "your-token-from-panel";

            /* Death By Captcha Socket Client
               Client client = (Client) new SocketClient(username, password);
               Death By Captcha http Client */
            Client client = (Client) new HttpClient(username, password);

            /* To use token authentication the first parameter must be "authtoken".
            Client client = (Client) new HttpClient("authtoken", token_from_panel); */

            // Put your Proxy credentials and type here
            string proxy = "http://user:password@127.0.0.1:1234";
            string proxyType = "HTTP";
            string pageurl = "https://client-demo.testsite.com/test-keycaptcha";
            string s_s_c_user_id = "valid_UID";
            string s_s_c_session_id = "valid_session_ID";
            string s_s_c_web_server_sign = "valid_webserver_sign";
            string  s_s_c_web_server_sign2 = "valid_webserver_sign2";

            string keycaptchaParams = "{\"proxy\": \"" + proxy + "\"," +
                                    "\"proxytype\": \"" + proxyType + "\"," +
                                    "\"s_s_c_user_id\": \"" + s_s_c_user_id + "\"," +
                                    "\"s_s_c_session_id\": \"" + s_s_c_session_id + "\"," +
                                    "\"s_s_c_web_server_sign\": \"" + s_s_c_web_server_sign + "\"," +
                                    "\"s_s_c_web_server_sign2\": \"" + s_s_c_web_server_sign2 + "\"," +
                                    "\"pageurl\": \"" + pageurl + "\"}";
            try
            {
                double balance = client.GetBalance();

                /* Upload a CAPTCHA and poll for its status. Put the KeyCaptcha
                   Json payload, CAPTCHA type and desired solving timeout (in seconds)
                   here. If solved, you'll receive a DeathByCaptcha.Captcha object. */
                Captcha captcha = client.Decode(Client.DefaultTimeout,
                    new Hashtable()
                    {
                        {"type", 10},
                        {"keycaptcha_params", keycaptchaParams}
                    });

                if (null != captcha)
                {
                    /* The CAPTCHA was solved; captcha.Id property holds
                    its numeric ID, and captcha.Text holds its text. */
                    Console.WriteLine("CAPTCHA {0} solved: {1}", captcha.Id,
                        captcha.Text);

//                  if ( /* check if the CAPTCHA was incorrectly solved */)
//                  {
//                      client.Report(captcha);
//                  }
                }
            }
            catch (AccessDeniedException e)
            {
                /* Access to DBC API denied, check your credentials and/or balance */
                Console.WriteLine("<<< catch : " + e.ToString());
            }
        }
    }
}
